package com.sun.corba.se.spi.activation;

import java.io.ObjectOutputStream;
import java.io.IOException;
import org.omg.CORBA.ORB;
import java.io.ObjectInputStream;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.portable.RemarshalException;
import org.omg.CORBA.portable.ApplicationException;
import org.omg.CORBA.MARSHAL;
import org.omg.CORBA.portable.ObjectImpl;

public class _ServerStub extends ObjectImpl implements Server
{
    private static String[] __ids;
    
    public _ServerStub() {
    }
    
    public void shutdown() {
        InputStream inputStream = null;
        try {
            inputStream = this._invoke(this._request("shutdown", true));
            return;
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            this.shutdown();
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public void install() {
        InputStream inputStream = null;
        try {
            inputStream = this._invoke(this._request("install", true));
            return;
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            this.install();
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public void uninstall() {
        InputStream inputStream = null;
        try {
            inputStream = this._invoke(this._request("uninstall", true));
            return;
        }
        catch (ApplicationException ex) {
            inputStream = ex.getInputStream();
            throw new MARSHAL(ex.getId());
        }
        catch (RemarshalException ex2) {
            this.uninstall();
        }
        finally {
            this._releaseReply(inputStream);
        }
    }
    
    public String[] _ids() {
        return (String[])(String[])_ServerStub.__ids.clone();
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException {
        String utf = objectInputStream.readUTF();
        ORB init = ORB.init(null, null);
        try {
            this._set_delegate(((ObjectImpl)init.string_to_object(utf))._get_delegate());
        }
        finally {
            init.destroy();
        }
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        ORB init = ORB.init(null, null);
        try {
            objectOutputStream.writeUTF(init.object_to_string(this));
        }
        finally {
            init.destroy();
        }
    }
    
    static {
        _ServerStub.__ids = new String[] { "IDL:activation/Server:1.0" };
    }
}
